Include "C:\Program Files\Blitz3D\userlibs\xors3d.bb"

SeedRnd MilliSecs ()
xGraphics3D 1024,768,32,0,1

; 
Global cam=xCreateCamera ()
xPositionEntity cam ,0,2,-20

; 
light=xCreateLight ()
xPositionEntity light,0,50,0

; 
pol=xCreateCube ()
xEntityPickMode pol,2
texpol=xLoadTexture ("Pol_plitka_COLOR.png")
xEntityTexture pol,texpol
xScaleTexture texpol,.1,.1
xScaleEntity pol,100,0,100
xEntityAddTriMeshShape(pol,0)

;     
vecone=xCreateCone()
xScaleEntity vecone,.1,.7,.1

;  ===============================
cub=xCreateCube ()
tex=xLoadTexture ("Pol_COLOR.png")
xEntityTexture cub,tex
xHideEntity cub

For i=1 To 20
	pxCube=xCopyEntity(cub)
	xEntityPickMode pxCube,2
	xPositionEntity pxCube,0,i*3,0
	xRotateEntity pxCube,Rnd(1,360),Rnd(1,360),Rnd(1,360)
	xEntityAddBoxShape (pxCube,1)
	xEntityFriction (pxCube,1)
Next 
;===========================================

While Not xKeyHit (1)

pick=xCameraPick (cam,xMouseX(),xMouseY())

xTFormPoint xPickedX(),xPickedY(),xPickedZ(),0,pick
tfpx#=xTFormedX()
tfpy#=xTFormedY()
tfpz#=xTFormedZ()

xTFormNormal 0,0,1,cam,0
tfvx#=xTFormedX()
tfvy#=xTFormedY()
tfvz#=xTFormedZ()

xEntityParent vecone,Pick
xPositionEntity vecone,tfpx,tfpy,tfpz
xEntityParent vecone,0
xAlignToVector vecone,tfvx,tfvy,tfvz,2,1

If xMouseHit (1)  And pick<>0 Then xEntityApplyImpulse(pick,tfvx*9,tfvy*9,tfvz*9,tfpx,tfpy,tfpz)   ;

xWorldFrequency (xGetFPS())
UpdatePlayer()
xUpdateWorld
xRenderWorld

xText 10,10,"FPS= "+xGetFPS ()
xText 10,30,"TFormNormalX="+tfvx
xText 10,50,"TFormNormalY="+tfvy
xText 10,70,"TFormNormalZ="+tfvz
xText 10,90,"TFormPointX="+tfpx
xText 10,110,"TFormPointY="+tfpy
xText 10,130,"TFormPointZ="+tfpz
xText 10,150,"Pick="+pick
xFlip
Wend
End

Function UpdatePlayer() ;  ()

	msX#=xMouseYSpeed()*0.5
	msY#=xMouseXSpeed ()*0.5
	
	rmx#=rmx#+msx#
	rmy#=rmy#+msy#
	
	rmx#=rmx#/1.6
	rmy#=rmy#/1.6
	xTurnEntity cam,0,-rmy#/2,0,1
	xTurnEntity cam,rmx#/2,0,0
	
	xMoveMouse xGraphicsWidth()/2,xGraphicsHeight()/2
	;  
	If xKeyDown (17) Then xMoveEntity cam,0,0,.2;
	If xKeyDown (31) Then xMoveEntity cam,0,0,-.2;
	If xKeyDown(30) Then xMoveEntity cam,-.2,0,0;
	If xKeyDown(32) Then xMoveEntity cam,.2,0,0;

End Function
